"use strict";

var _interopRequireDefault = require("@babel/runtime-corejs2/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _stringify = _interopRequireDefault(require("@babel/runtime-corejs2/core-js/json/stringify"));

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/createClass"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/getPrototypeOf"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/inherits"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime-corejs2/helpers/defineProperty"));

var _react = require("react");

var _reactRouter = require("react-router");

var _propTypes = require("prop-types");

var getUrlFromLocation = function getUrlFromLocation(_ref) {
  var pathname = _ref.pathname,
      search = _ref.search,
      hash = _ref.hash;
  return "".concat(pathname).concat(search).concat(hash);
};

var LocationInterceptor =
/*#__PURE__*/
function (_Component) {
  (0, _inherits2.default)(LocationInterceptor, _Component);

  function LocationInterceptor() {
    (0, _classCallCheck2.default)(this, LocationInterceptor);
    return (0, _possibleConstructorReturn2.default)(this, (0, _getPrototypeOf2.default)(LocationInterceptor).apply(this, arguments));
  }

  (0, _createClass2.default)(LocationInterceptor, [{
    key: "componentDidUpdate",
    value: function componentDidUpdate(prevProps) {
      var _this$props = this.props,
          location = _this$props.location,
          onUrlChange = _this$props.onUrlChange,
          onLocationStateChange = _this$props.onLocationStateChange;
      var newUrl = getUrlFromLocation(location);

      if (newUrl !== getUrlFromLocation(prevProps.location)) {
        onUrlChange(newUrl);
      }

      if ((0, _stringify.default)(location.state) !== (0, _stringify.default)(prevProps.location.state)) {
        onLocationStateChange(location.state);
      }
    }
  }, {
    key: "render",
    value: function render() {
      return this.props.children;
    }
  }]);
  return LocationInterceptor;
}(_react.Component);

(0, _defineProperty2.default)(LocationInterceptor, "contextTypes", {
  router: _propTypes.object
});

var _default = (0, _reactRouter.withRouter)(LocationInterceptor);

exports.default = _default;